function [ f ] = gaussiancurvature( M )
%GAUSSIANCURVATURE Computes the gaussian curvature of each vertex of mesh M.
%   Returns vector f where f(i)== gaussian curvature of vertex i.

numberOfFaces = size(M.tri,1);
numberOfVertices = max(max(M.tri));

f = ones(numberOfVertices,1).*(2*pi);

V = [M.X, M.Y, M.Z];

for i=1:numberOfFaces
    for j=0:2
        v1 = V(M.tri(i,j+1),:);
        v2 = V(M.tri(i,mod(j+1,3)+1),:)-v1;
        v3 = V(M.tri(i,mod(j+2,3)+1),:)-v1;
        v2 = v2./(norm(v2));
        v3 = v3./(norm(v3));
        f(M.tri(i,j+1)) = f(M.tri(i,j+1))-acos(dot(v2,v3));
    end
end

end

